
import gdbm
import string
import regex

class link_statistic:
	def get(self):
		self.db = gdbm.open(self.file, "cr")
		self.db.close()
	
	def put(self, used):
		self.db = gdbm.open(self.file, "cw")
		self.db.close()
	
	def __init__(self, link_database_file, address):
		self.file = link_database_file
		self.addr = address

class limit:
	def add_line(self, line):
		words = string.split(line)
		self.add(words[0], words[1], words[2], words[3])
		
	def add(self, mask, number, size, time):
		self.masks.append(mask)
		self.number[mask] = number
		self.size[mask] = size
		self.time[mask] = time
	
	def get(self, address, listed, protected):
		for mask in self.masks:
			if ((string.lower(mask) == 'listed' and listed) or
			    (string.lower(mask) == 'protected' and protected) or
			    (regex.match(mask, address) >= 0)):
				return [self.number[mask], self.size[mask], self.time[mask]]
		return []
	
	def __init__(self):
		self.masks = []
		self.number = {}
		self.size = {}
		self.time = {}

class alias:
	def __init__(self, name, filename):
		self.name = name
		self.filename = filename

class config:
	def read_dir_list(self):
		yield = []
		fp = open(self.dir_list_file, 'r')
		line = fp.readline()
		while line:
			line = string.strip(line)
			if line != '':
				yield.append(line)
			line = fp.readline()
		fp.close()
		return yield
	
	def read_alias_list(self):
		yield = []
		fp = open(self.alias_list_file, 'r')
		line = fp.readline()
		while line:
			line = string.strip(line)
			if line != '':
				[name, filename] = string.split(line, None, 1)
				yield.append(alias(name, filename))
			line = fp.readline()
		fp.close()
		return yield
	
	def read(self, name):
		fp = open(name, 'r')
		line = fp.readline()
		while line:
			line = string.strip(line)
			args = string.split(line, None, 1)
			if line[0:1] != '#' and len(args) == 2:
				if string.lower(args[0]) == 'dir-list-file':
					self.dir_list_file = args[1]
				elif string.lower(args[0]) == 'alias-list-file':
					self.alias_list_file = args[1]
				elif string.lower(args[0]) == 'limit-day':
					self.limit_day.add_line(args[1])
				elif string.lower(args[0]) == 'limit-week':
					self.limit_week.add_line(args[1])
				elif string.lower(args[0]) == 'limit-month':
					self.limit_month.add_line(args[1])
				elif string.lower(args[0]) == 'spool-dir':
					self.spool_dir = args[1]
				elif string.lower(args[0]) == 'freq-policy':
					self.freq_policy = args[1]
				else:
					print "unknown config keyword:", args[0]
			line = fp.readline()
		fp.close()
		
	def __init__(self, name):
		self.dir_list_file = ''
		self.alias_list_file = ''
		self.limit_day = limit()
		self.limit_week = limit()
		self.limit_month = limit()
		self.spool_dir = ''
		self.freq_policy = ''
		self.read(name)

