#!/usr/bin/python

import sys
import posix
import os
import libconf
import libfbase

USRIF_CONFIG = '/usr/local/etc/u-srif/u-srif.conf'

##############################
# The main program starts here

if len(sys.argv) < 2:
	print 'usage:', sys.argv[0], '<[file] [file] ..>'
	sys.exit(1)

# Read configuration
Conf = libconf.config(USRIF_CONFIG)

FBase = libfbase.filebase(Conf.spool_dir)
FBase.open('r')

print libfbase.file_info_header

for filename in sys.argv[1:]:
	files_list = FBase.get(filename)
	if files_list == None:
		print 'Cannot find file', filename
	else:
		for file in files_list:
			file.stat()
#			print 'Full name: %s (%d bytes)' % (file.fullname, file.size)
#			if file.desc:
#				print 'Description:', file.desc
#			if file.area:
#				print 'Area:', file.area
#			if file.dlcnt > 0:
#				print 'Downloads counter:', file.dlcnt
			print libfbase.format_file_info(file.name, file.size, file.desc)

FBase.close()
sys.exit(0)

